/*==================================================================
=  ļ  : Grambase
=  Ҫ: 
=  ޸: 
=      : shen beide
====================================================================*/

#if !defined(_GRAMBASE_H)
#define _GRAMBASE_H

#include "PubHeader.h"

#include "Array.h"
#include "ObArray.h"
#include "ObList.h"

//////////////////////////////////////////
class GramRules;
class GramState;

#define GRAM_FUNC_HEADER '$'

class GramTransition
{
public:
    bool        m_isGramFunc;       // GramFunc(ʱ$ͷ)  GramString 
    OTSTR       m_strCondition;    // Ϊʱ, ʾֱת
    GramState*  m_pNextGramState;
};

class GramState
{
public:
    long     m_nId;

    /////////////////////////////////////////////
    long     m_RuleId;

    TObArray<GramTransition> m_TransitionList;

public:    
    GramState(long nId=1);
   ~GramState();

    ///////////////////////////////////////////////
    bool AddTransition(bool isGramFunc, char* szCondition, GramState* pNextState);
    GramState* FindTransition(bool isGramFunc, char* szCondition,bool bCaseSensitive,bool bReverseFind,bool& isLastTransition);
    
    bool isAcceptable() { return (m_RuleId==-1)? false:true; }

    friend class LexRules;

    OTSTR m_strTransitionDescription;
};


#endif
